#!/bin/sh

echo "Do not run me! - I am an experiment..."
exit 0

/etc/init.d/iptables stop

first=0

mangle_id=$first
mangle() {
	mangle_id=$[mangle_id + 1]
	
	iptables -t $FUNCNAME -A $1 -p icmp -j LOG --log-prefix="$1/$FUNCNAME [$mangle_id]: "
	iptables -t $FUNCNAME -A $1 -p icmp -j MARK --set-mark $mangle_id
	
	iptables -t $FUNCNAME -A $1 -m unclean -j LOG --log-prefix="$1/$FUNCNAME UNCLEAN: "
	iptables -t $FUNCNAME -A $1 -j ACCEPT
}

# This will not produce the error, but no mangling on INPUT
#for x in `iptables -t mangle -nxvL | grep "^Chain " | cut -d ' ' -f 2 | grep -v INPUT`

# This produces an error
for x in `iptables -t mangle -nxvL | grep "^Chain " | cut -d ' ' -f 2`
do
	mangle $x
done


filter() {
	y=$first
	while [ $y -lt ${mangle_id} ]
	do
		y=$[y + 1]
		iptables -t $FUNCNAME -A $1 -m mark --mark $y -j LOG --log-prefix="$1/$FUNCNAME [$y]: "
	done
	
	iptables -t $FUNCNAME -A $1 -m unclean -j LOG --log-prefix="$1/$FUNCNAME UNCLEAN: "
	iptables -t $FUNCNAME -A $1 -j ACCEPT
}

for x in `iptables -t filter -nxvL | grep "^Chain " | cut -d ' ' -f 2`
do
	filter $x
done




nat() {
	y=$first
	while [ $y -lt ${mangle_id} ]
	do
		y=$[y + 1]
		iptables -t $FUNCNAME -A $1 -m mark --mark $y -j LOG --log-prefix="$1/$FUNCNAME [$y]: "
	done
	
	iptables -t $FUNCNAME -A $1 -m unclean -j LOG --log-prefix="$1/$FUNCNAME UNCLEAN: "
	iptables -t $FUNCNAME -A $1 -j ACCEPT
}

for x in `iptables -t nat -nxvL | grep "^Chain " | cut -d ' ' -f 2`
do
	nat $x
done


exit 0


INPUT -- request FROM a remote host
-----------------------------------
[root@194.30.193.23]# ping -c 1 195.97.5.206

[request]
Jan  4 02:34:57 gateway kernel: PREROUTING/mangle [1]: IN=ppp0 OUT= MAC= SRC=194.30.193.23 DST=195.97.5.206 LEN=84 TOS=0x00 PREC=0x00 TTL=61 ID=0 DF PROTO=ICMP TYPE=8 CODE=0 ID=34827 SEQ=0
Jan  4 02:34:57 gateway kernel: PREROUTING/nat    [1]: IN=ppp0 OUT= MAC= SRC=194.30.193.23 DST=195.97.5.206 LEN=84 TOS=0x00 PREC=0x00 TTL=61 ID=0 DF PROTO=ICMP TYPE=8 CODE=0 ID=34827 SEQ=0
Jan  4 02:34:57 gateway kernel: INPUT/mangle [2]: IN=ppp0 OUT= MAC= SRC=194.30.193.23 DST=195.97.5.206 LEN=84 TOS=0x00 PREC=0x00 TTL=61 ID=0 DF PROTO=ICMP TYPE=8 CODE=0 ID=34827 SEQ=0
Jan  4 02:34:57 gateway kernel: INPUT/filter [2]: IN=ppp0 OUT= MAC= SRC=194.30.193.23 DST=195.97.5.206 LEN=84 TOS=0x00 PREC=0x00 TTL=61 ID=0 DF PROTO=ICMP TYPE=8 CODE=0 ID=34827 SEQ=0

[reply] !!! this is error !!!
Jan  4 02:34:57 gateway kernel: OUTPUT/mangle [4]: IN= OUT=lo SRC=195.97.5.206 DST=195.97.5.206 LEN=84 TOS=0x00 PREC=0x00 TTL=64 ID=9466 PROTO=ICMP TYPE=0 CODE=0 ID=34827 SEQ=0
Jan  4 02:34:57 gateway kernel: OUTPUT/filter [4]: IN= OUT=lo SRC=195.97.5.206 DST=195.97.5.206 LEN=84 TOS=0x00 PREC=0x00 TTL=64 ID=9466 PROTO=ICMP TYPE=0 CODE=0 ID=34827 SEQ=0
Jan  4 02:34:57 gateway kernel: POSTROUTING/mangle [5]: IN= OUT=lo SRC=195.97.5.206 DST=195.97.5.206 LEN=84 TOS=0x00 PREC=0x00 TTL=64 ID=9466 PROTO=ICMP TYPE=0 CODE=0 ID=34827 SEQ=0
Jan  4 02:34:57 gateway kernel: PREROUTING/mangle [1]: IN=lo OUT= MAC=00:00:00:00:00:00:00:00:00:00:00:00:08:00 SRC=195.97.5.206 DST=195.97.5.206 LEN=84 TOS=0x00 PREC=0x00 TTL=64 ID=9466 PROTO=ICMP TYPE=0 CODE=0 ID=34827 SEQ=0
Jan  4 02:34:57 gateway kernel: INPUT/mangle [2]: IN=lo OUT= MAC=00:00:00:00:00:00:00:00:00:00:00:00:08:00 SRC=195.97.5.206 DST=195.97.5.206 LEN=84 TOS=0x00 PREC=0x00 TTL=64 ID=9466 PROTO=ICMP TYPE=0 CODE=0 ID=34827 SEQ=0
Jan  4 02:34:57 gateway kernel: INPUT/filter [2]: IN=lo OUT= MAC=00:00:00:00:00:00:00:00:00:00:00:00:08:00 SRC=195.97.5.206 DST=195.97.5.206 LEN=84 TOS=0x00 PREC=0x00 TTL=64 ID=9466 PROTO=ICMP TYPE=0 CODE=0 ID=34827 SEQ=0


INPUT -- the same as above, without mangling on INPUT
-----------------------------------------------------
[root@194.30.193.23]# ping -c 1 195.97.5.206

[request]
Jan  4 02:53:26 gateway kernel: PREROUTING/mangle [1]: IN=ppp0 OUT= MAC= SRC=194.30.193.23 DST=195.97.5.206 LEN=84 TOS=0x00 PREC=0x00 TTL=61 ID=0 DF PROTO=ICMP TYPE=8 CODE=0 ID=46859 SEQ=0
Jan  4 02:53:26 gateway kernel: PREROUTING/nat    [1]: IN=ppp0 OUT= MAC= SRC=194.30.193.23 DST=195.97.5.206 LEN=84 TOS=0x00 PREC=0x00 TTL=61 ID=0 DF PROTO=ICMP TYPE=8 CODE=0 ID=46859 SEQ=0
Jan  4 02:53:26 gateway kernel: INPUT/filter [1]: IN=ppp0 OUT= MAC= SRC=194.30.193.23 DST=195.97.5.206 LEN=84 TOS=0x00 PREC=0x00 TTL=61 ID=0 DF PROTO=ICMP TYPE=8 CODE=0 ID=46859 SEQ=0

[reply]
Jan  4 02:53:26 gateway kernel: OUTPUT/mangle [3]: IN= OUT=ppp0 SRC=195.97.5.206 DST=194.30.193.23 LEN=84 TOS=0x00 PREC=0x00 TTL=64 ID=12709 PROTO=ICMP TYPE=0 CODE=0 ID=46859 SEQ=0
Jan  4 02:53:26 gateway kernel: OUTPUT/filter [3]: IN= OUT=ppp0 SRC=195.97.5.206 DST=194.30.193.23 LEN=84 TOS=0x00 PREC=0x00 TTL=64 ID=12709 PROTO=ICMP TYPE=0 CODE=0 ID=46859 SEQ=0
Jan  4 02:53:26 gateway kernel: POSTROUTING/mangle [4]: IN= OUT=ppp0 SRC=195.97.5.206 DST=194.30.193.23 LEN=84 TOS=0x00 PREC=0x00 TTL=64 ID=12709 PROTO=ICMP TYPE=0 CODE=0 ID=46859 SEQ=0


OUTPUT -- request TO a remote host
------
[root@195.97.5.206]# ping -c 1 194.30.193.23

[request]
Jan  4 02:12:39 gateway kernel: OUTPUT/mangle [4]: IN= OUT=ppp0 SRC=195.97.5.206 DST=194.30.193.23 LEN=84 TOS=0x00 PREC=0x00 TTL=64 ID=0 DF PROTO=ICMP TYPE=8 CODE=0 ID=41252 SEQ=256
Jan  4 02:12:39 gateway kernel: OUTPUT/nat [4]: IN= OUT=ppp0 SRC=195.97.5.206 DST=194.30.193.23 LEN=84 TOS=0x00 PREC=0x00 TTL=64 ID=0 DF PROTO=ICMP TYPE=8 CODE=0 ID=41252 SEQ=256
Jan  4 02:12:39 gateway kernel: OUTPUT/filter [4]: IN= OUT=ppp0 SRC=195.97.5.206 DST=194.30.193.23 LEN=84 TOS=0x00 PREC=0x00 TTL=64 ID=0 DF PROTO=ICMP TYPE=8 CODE=0 ID=41252 SEQ=256
Jan  4 02:12:39 gateway kernel: POSTROUTING/mangle [5]: IN= OUT=ppp0 SRC=195.97.5.206 DST=194.30.193.23 LEN=84 TOS=0x00 PREC=0x00 TTL=64 ID=0 DF PROTO=ICMP TYPE=8 CODE=0 ID=41252 SEQ=256
Jan  4 02:12:39 gateway kernel: POSTROUTING/nat [5]: IN= OUT=ppp0 SRC=195.97.5.206 DST=194.30.193.23 LEN=84 TOS=0x00 PREC=0x00 TTL=64 ID=0 DF PROTO=ICMP TYPE=8 CODE=0 ID=41252 SEQ=256

[reply]
Jan  4 02:12:39 gateway kernel: PREROUTING/mangle [1]: IN=ppp0 OUT= MAC= SRC=194.30.193.23 DST=195.97.5.206 LEN=84 TOS=0x00 PREC=0x00 TTL=252 ID=5905 PROTO=ICMP TYPE=0 CODE=0 ID=41252 SEQ=256
Jan  4 02:12:39 gateway kernel: INPUT/mangle [2]: IN=ppp0 OUT= MAC= SRC=194.30.193.23 DST=195.97.5.206 LEN=84 TOS=0x00 PREC=0x00 TTL=252 ID=5905 PROTO=ICMP TYPE=0 CODE=0 ID=41252 SEQ=256
Jan  4 02:12:39 gateway kernel: INPUT/filter [2]: IN=ppp0 OUT= MAC= SRC=194.30.193.23 DST=195.97.5.206 LEN=84 TOS=0x00 PREC=0x00 TTL=252 ID=5905 PROTO=ICMP TYPE=0 CODE=0 ID=41252 SEQ=256



FORWARD -- request FROM and TO a remote host THROUGH local host
---------------------------------------------------------------
[root@194.30.193.23]# ping -c 1 195.97.5.194

[request]
Jan  4 02:25:25 gateway kernel: PREROUTING/mangle [1]: IN=ppp0 OUT= MAC= SRC=194.30.193.23 DST=195.97.5.194 LEN=84 TOS=0x00 PREC=0x00 TTL=61 ID=0 DF PROTO=ICMP TYPE=8 CODE=0 ID=16395 SEQ=0
Jan  4 02:25:25 gateway kernel: PREROUTING/nat    [1]: IN=ppp0 OUT= MAC= SRC=194.30.193.23 DST=195.97.5.194 LEN=84 TOS=0x00 PREC=0x00 TTL=61 ID=0 DF PROTO=ICMP TYPE=8 CODE=0 ID=16395 SEQ=0
Jan  4 02:25:25 gateway kernel: FORWARD/mangle [3]: IN=ppp0 OUT=eth0 SRC=194.30.193.23 DST=195.97.5.194 LEN=84 TOS=0x00 PREC=0x00 TTL=60 ID=0 DF PROTO=ICMP TYPE=8 CODE=0 ID=16395 SEQ=0
Jan  4 02:25:25 gateway kernel: FORWARD/filter [3]: IN=ppp0 OUT=eth0 SRC=194.30.193.23 DST=195.97.5.194 LEN=84 TOS=0x00 PREC=0x00 TTL=60 ID=0 DF PROTO=ICMP TYPE=8 CODE=0 ID=16395 SEQ=0
Jan  4 02:25:25 gateway kernel: POSTROUTING/mangle [5]: IN= OUT=eth0 SRC=194.30.193.23 DST=195.97.5.194 LEN=84 TOS=0x00 PREC=0x00 TTL=60 ID=0 DF PROTO=ICMP TYPE=8 CODE=0 ID=16395 SEQ=0
Jan  4 02:25:25 gateway kernel: POSTROUTING/nat    [5]: IN= OUT=eth0 SRC=194.30.193.23 DST=195.97.5.194 LEN=84 TOS=0x00 PREC=0x00 TTL=60 ID=0 DF PROTO=ICMP TYPE=8 CODE=0 ID=16395 SEQ=0

[reply]
Jan  4 02:25:25 gateway kernel: PREROUTING/mangle [1]: IN=eth0 OUT= MAC=00:50:fc:21:9a:ab:00:50:fc:21:9a:e6:08:00 SRC=195.97.5.194 DST=194.30.193.23 LEN=84 TOS=0x00 PREC=0x00 TTL=128 ID=60687 DF PROTO=ICMP TYPE=0 CODE=0 ID=16395 SEQ=0
Jan  4 02:25:25 gateway kernel: FORWARD/mangle [3]: IN=eth0 OUT=ppp0 SRC=195.97.5.194 DST=194.30.193.23 LEN=84 TOS=0x00 PREC=0x00 TTL=127 ID=60687 DF PROTO=ICMP TYPE=0 CODE=0 ID=16395 SEQ=0
Jan  4 02:25:25 gateway kernel: FORWARD/filter [3]: IN=eth0 OUT=ppp0 SRC=195.97.5.194 DST=194.30.193.23 LEN=84 TOS=0x00 PREC=0x00 TTL=127 ID=60687 DF PROTO=ICMP TYPE=0 CODE=0 ID=16395 SEQ=0
Jan  4 02:25:25 gateway kernel: POSTROUTING/mangle [5]: IN= OUT=ppp0 SRC=195.97.5.194 DST=194.30.193.23 LEN=84 TOS=0x00 PREC=0x00 TTL=127 ID=60687 DF PROTO=ICMP TYPE=0 CODE=0 ID=16395 SEQ=0
